<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Event and Event listener Practice</title>
</head>
<body>

    <!-- Basic Implementation of Event Binding with HTML Attributes -->
    <h5>Event Binding with HTML Attributes</h5>
    <button onclick="alert('Button clicked using Event Binding in HTML Attributes');">
        Click Me
    </button>

    <br><br>

    <!-- Event Binding with HTML attributes using UDF -->
    <h5>Event Binding with HTML Attributes using UDF</h5>
    <button onclick="show()" id="udf-button">
        Click Me
    </button>

    <!-- Event Binding with JS -->
    <h5>Event Binding with JS</h5>
    <button id="mybtn">Click Me</button>

    <!-- Problem of Overriding Event Handlers-->
    <h5>Problem of Overriding Event Handlers</h5>
    <button id="btnOverriding">Click Me</button>

    <!-- Implementing addEventListener() -->
    <h5>Using addEventListener()</h5>
    <button id="addEventButton">Click Me</button>

    <!-- Solve Overriding Problem using addEventListener() -->
    <h5>Solve Overriding Problem using addEventListener()</h5>
    <button id="addEventOverriding">Click Me</button>

    <script id="udf-button-script">
        function show(){
            alert('Button clicked in UDF');
        }
    </script>
    <script id="mybtn-script">
       
        
        //Method #1
        var btn= document.getElementById("mybtn");
        btn.onclick= function(){alert("Button Clicked using Event Binding in JS #1");};
        
        
        /*
        //Method #2
        document.getElementById("mybtn").onclick = function(){alert("Button Clicked using Event Binding in JS #2")};
        */

        /*
        //Method #3
        function disp(){alert("Button Clicked using Event Binding in JS #3");}
        document.getElementById("mybtn").onclick= disp;
        */
    </script>
    <script id="btnOverriding-script">

        function disp1(){alert("Button Clicked 1");}
        function disp2(){alert("Button Clicked 2");}
        document.getElementById("btnOverriding").onclick= disp1;
        document.getElementById("btnOverriding").onclick= disp2;
    </script>
    <script id="addEventButton-script">

        
        //Method 1
        var btn= document.getElementById("addEventButton");
        btn.addEventListener("click",function(){alert('Button for addEventListener()');});
        

        /*
        //Method 2
        function show(){
            alert("Button Clicked");
        }
        var btn= document.getElementById("addEventButton");
        btn.addEventListener("mouseover",show);
        */
    </script>
    <script id="addEventOverriding-script">
        function disp1(){
            alert('Button Clicked 1');
        }
        function disp2(){
            alert("Button Clicked 2");
        }

        var btn = document.getElementById("addEventOverriding");

        btn.addEventListener("click", disp1);
        btn.addEventListener("click", disp2);
    </script>
</body>
</html>